% This function takes a set of vertices and returns a matrix of points
% inside the convex hull of such vertices

function [out] = ReturnFilled(vertices, Ngrid)

% First rearrange the points
ind = convhull(vertices(:,1),vertices(:,2));
Xvert = vertices(:,1); Yvert = vertices(:,2);
                
% Then make a grid around this stuff
Xaxis = linspace(min(Xvert),max(Xvert),Ngrid); % grid x-axis from smallest to largest value of theta_p
Yaxis = linspace(min(Yvert),max(Yvert),Ngrid); % grid y-axis from smallest to largest value of theta_p
[mg1, mg2] = meshgrid(Xaxis,Yaxis);                             % create mesh grid
grid = [mg1(:), mg2(:)];                                          % grid of points containing the initial estimate
                
% If we passed the check, will now grid the set, check if points are in
FlagInSet = inpolygon(mg1(:), mg2(:), Xvert(ind), Yvert(ind));                

if sum(FlagInSet) > 0
    out = grid(FlagInSet,:);
else
    out = [];
end